module NML
implicit none

contains
    
real function Fmin(Fun, AX, BX, Eps)
! FMIN  :  . 
!"   " .  1980
interface
  real function Fun(x)
    real, intent(in):: x
  end function Fun
end interface
real, intent(in):: AX, BX, Eps
real SQME, A, B, C, D, E, X, Xm, P, Q, R
real FX, FU, FV, FW, Tol1, Tol2, U, V, W
!begin
  SQME=sqrt(epsilon(1.0)/2.0)
  C=0.5*(3.0-sqrt(5.0))
      !  
  A=AX; B=BX
  X=A+C*(B-A); V=X; W=X
  FX=Fun(X); FV=FX; FW=FX; E=0.0
20 continue      !  
  Xm=0.5*(A+B)
  Tol1=SQME*abs(X)+Eps/3.0
  Tol2=2.0*Tol1
      !  
  if (abs(X-Xm)<=(Tol2-0.5*abs(B-A))) then
    Fmin=X; return
  end if
      !   
  if (abs(E)<=Tol1) goto 40
      ! 
  R=(X-W)*(FX-FV)
  Q=(X-V)*(FX-FW)
  P=(X-V)*Q-(X-W)*R
  Q=2.0*(Q-R)
  if (Q>0.0) then; P=-P; else; Q=abs(Q); end if
  R=E; E=D
30 continue      !  
  if (abs(P)>=abs(0.5*Q*R)) goto 40
  if (P<=Q*(A-X)) goto 40
  if (P>=Q*(B-X)) goto 40
      !  
  D=P/Q; U=X+D
      !Fun       AX  BX
  if ((U-A)<Tol2) D=sign(Tol1, Xm-X)
  if ((B-U)<Tol2) D=sign(Tol1, Xm-X)
  goto 50
40 continue      !  
  if (X>=Xm) then; E=A-X
             else; E=B-X
  end if
  D=C*E
50 continue      !Fun       X
  if (abs(D)>=Tol1) then; U=X+D
                   else; U=X+sign(Tol1,D)
  end if
  FU=Fun(U)
      !    A, B, V, W, X
  if (FU<=FX) then
    if (U>=X) then; A=X; else; B=X; end if
    V=W; FV=FW
    W=X; FW=FX
    X=U; FX=FU
  else
    if (U<X) then; A=U; else; B=U; end if
    if (FU<=FW.OR.W==X) then
      V=W; FV=FW
      W=U; FW=FU
    else if (FU<=FV.OR.V==X.OR.V==W) then
      V=U; FV=FU
    end if
  end if         !  
  goto 20
end function Fmin

end module NML
